type huffman = Entier of int | N of huffman*huffman ;;
type 'a cell = {prio:int;content:'a} and
  'a prio_file = Nil | Node of 'a cell*'a prio_file*'a prio_file ;;

let rec dcode_caractre l arbre = match arbre with
  |Entier c -> (c-550,l)
  |N(g,d) -> if (hd l=0) then (dcode_caractre (tl l) g)
                          else (dcode_caractre (tl l) d);;

let rec dcode_texte arbre l = match l with
  | [] -> [] 
  | _ -> let (a,r) = (dcode_caractre l arbre) in a::(dcode_texte arbre r) ;;
  
let head = function
  | Nil -> failwith "tu n'as pas de tte"
  | Node (a,_,_) -> a ;;
  
let rec supp = function
  | Nil -> failwith "tu n'as pas de tte"
  | Node (_,f1,Nil) -> f1
  | Node (_,Nil,f2) -> f2
  | Node (a,f1,f2) -> let h1 = head f1 and h2 = head f2 in  
                      if h1 < h2 then Node (h1,supp f1,f2)
                                else supp (Node(a,f2,f1)) ;;
                                
# open "random" ;;
  
let rec insert x prio file = match file with
  | Nil -> Node({prio=prio;content=x},Nil,Nil)
  | Node (a,g,d) -> if a.prio >= prio then
                      if (int 2=0) then
                          Node({prio=prio;content=x},(insert a.content a.prio g),d)
                      else Node({prio=prio;content=x},g,(insert a.content a.prio d))
      else 
        if (int 2) = 0 then Node (a,(insert x prio g),d)
                      else Node (a,g,(insert x prio d)) ;;

let pretraitement_1 l =
  let t=make_vect 1101 0 in
    let rec aux l t = match l with
      |[] -> t
      |x::l1 -> t.(x+550) <- 1+ t.(x+550) ; aux l1 t ;
in
  aux l t;;
  
let pretraitement lst =
  let t = pretraitement_1 lst in
  let p = ref Nil in
  for i=0 to 1100 do
    if t.(i)<>0 then p:=(insert (Entier (i)) t.(i) !p) done ;
      !p;;

let huffman lst =
  let t=pretraitement lst in
  let rec aux l = match l with
    | Nil -> failwith "vide"
    | Node (a,Nil,Nil) -> a.content
    | Node (a,_,_) -> let x = head l in let p=supp l in let y =head p in
      aux (insert (N(x.content,y.content)) (x.prio + y.prio) (supp p))
  in aux t ;;
  
let table huff = 
  let v = make_vect 1101 [] in
  let rec tb lis = function
    | Entier n -> v.(n) <- rev lis
    |N(huff1,huff2) -> tb (0::lis) huff1; tb (1::lis) huff2
    | _ -> failwith ("Erreur dans table");
in tb [] huff ;
v;;

let rec coder table = function
    | [] -> []
    | i::l -> (table.(i+550))@(coder table l) ;;
    
let codage lst =
  let huff = huffman lst in
  let tab = table huff in
  let code = coder tab lst in
  (huff,code) ;;
  
let test lst =
  let (h,c) = codage lst in
  dcode_texte h c ;;