# open "graphics";;
open_graph "";;
clear_graph () ;;
  
let taille = 5 ;;

let rec div_int a b = match b with
  |1 -> a
  |2 -> if a>0 then (a+1) lsr 1 else -((1-a) lsr 1)
  |_ -> div_int (a/(b lsr 1)) 2;;

let yuv_to_rvb (y,u,v) =
  let y2 = 128+y in
    (y2+(div_int (14*u) 10),y2-(div_int (344*v+714*u) 1000),y2+(div_int (177*v) 100)) ;;
    
let rvb_to_yuv (r,v,b) =
 ((div_int (299*r+587*v+114*b) 1000) - 128,
 (div_int (500*r-419*v-81*b) 1000) , (div_int (-168*r-331*v+500*b) 1000)) ;;
 

let nuance_rouge x =
  set_color (rgb (128+x) 0 0);;
  
let nuance_bleu x =
  set_color (rgb 0 0 (128+x));;
  
let nuance_vert x =
  set_color (rgb 0 (128+x) 0);;
 
let nuance_y x =
  let (r,g,b) = yuv_to_rvb (x,0,0) in
  set_color ( rgb r g b);;
  
let nuance_u x =
  let (r,g,b) = yuv_to_rvb (0,x,0) in
  set_color ( rgb r g b);;
  
let nuance_v x =
  let (r,g,b) = yuv_to_rvb (0,0,x) in
  set_color ( rgb r g b);;
  
let fonc_of_coul couleur = match couleur with
 | "vert" -> nuance_vert
 | "b" -> nuance_bleu
 | "r" -> nuance_rouge
 | "y" -> nuance_y
 | "u" -> nuance_u
 | "v" -> nuance_v
 | _ -> failwith ("Connait pas: "^couleur);;
 
let test couleur diff = 
  let nuance = fonc_of_coul couleur in  
  clear_graph ();
  for x=25/taille to 190/taille do
   let d = if (x mod 2)=0 then diff else (-diff) in
    for y=25/taille to 100/taille do
      nuance d;
      fill_rect (2*taille*y) (taille*x) taille taille;
      nuance (-d);
      fill_rect (2*taille*y+taille) (taille*x) taille taille;
 done; done;
 set_color black;
 moveto 40 200 ;
 draw_string (couleur^" avec une variation de "^(string_of_int diff));;